/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreNojumplistRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreNojumplist extends TableImpl<VCoreNojumplistRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_nojumplist</code>
     */
    public static final VCoreNojumplist V_CORE_NOJUMPLIST = new VCoreNojumplist();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreNojumplistRecord> getRecordType() {
        return VCoreNojumplistRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_nojumplist.fk_element</code>.
     */
    public final TableField<VCoreNojumplistRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_nojumplist.nojumplist</code>.
     */
    public final TableField<VCoreNojumplistRecord, String> NOJUMPLIST = createField(DSL.name("nojumplist"), SQLDataType.CLOB, this, "");

    private VCoreNojumplist(Name alias, Table<VCoreNojumplistRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreNojumplist(Name alias, Table<VCoreNojumplistRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_nojumplist" as  SELECT v.key_variable AS fk_element,
          string_agg(to_char(mc.num_missingcode, '99999'::text), ','::text) AS nojumplist
         FROM ((((common_dd.t_core_variable v
           LEFT JOIN common_dd.t_core_missingvalue mv ON ((mv.fk_missinglist = v.fk_missinglist)))
           LEFT JOIN common_dd.t_core_missingmaster mm ON ((mm.pk = mv.fk_missingmaster)))
           LEFT JOIN common_dd.t_dm_missingvalue dmv ON ((dmv.fk_core_missingvalue = mv.pk)))
           LEFT JOIN common_dd.t_dm_missingcode mc ON ((mc.pk = dmv.fk_missingcode)))
        WHERE (mm.reproducible = false)
        GROUP BY v.key_variable;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_nojumplist</code> table
     * reference
     */
    public VCoreNojumplist(String alias) {
        this(DSL.name(alias), V_CORE_NOJUMPLIST);
    }

    /**
     * Create an aliased <code>common_dd.v_core_nojumplist</code> table
     * reference
     */
    public VCoreNojumplist(Name alias) {
        this(alias, V_CORE_NOJUMPLIST);
    }

    /**
     * Create a <code>common_dd.v_core_nojumplist</code> table reference
     */
    public VCoreNojumplist() {
        this(DSL.name("v_core_nojumplist"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreNojumplist as(String alias) {
        return new VCoreNojumplist(DSL.name(alias), this);
    }

    @Override
    public VCoreNojumplist as(Name alias) {
        return new VCoreNojumplist(alias, this);
    }

    @Override
    public VCoreNojumplist as(Table<?> alias) {
        return new VCoreNojumplist(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreNojumplist rename(String name) {
        return new VCoreNojumplist(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreNojumplist rename(Name name) {
        return new VCoreNojumplist(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreNojumplist rename(Table<?> name) {
        return new VCoreNojumplist(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreNojumplist where(Condition condition) {
        return new VCoreNojumplist(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreNojumplist where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreNojumplist where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreNojumplist where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreNojumplist where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreNojumplist where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreNojumplist where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreNojumplist where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreNojumplist whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreNojumplist whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
